/*
 *		BCR Mail Handler, version 3.1
 *
 *	      Copyright (c) 1994 Bill C. Riemers
 *		  All Rights Reserved
 *
 *  This following is the standard GNU notice of copyright.  The only
 *  exception is I maintain I own this program and reserve all future
 *  rights.  (Meaning I might use a different copyright on future 
 *  releases, or violate my own copyright anyway I see fit.)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; version 2 of the License.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#define IS_GETOPT
#define IS_TYPES
#define IS_FCNTL
#define IS_STDIO
#define IS_UNISTD
#define IS_SIGNAL
#define IS_STRING
#define IS_STAT
#define IS_STDLIB

#include "config.h"
#include "includes.h"
#include "prototypes.h"


/* Terminate the old daemon gracefully 
 */

void daemonkill(char *daemon,int kill_daemon){
  int pid;

  fprintf(fstdio[1],"Attempting to kill any old %s daemons\n",daemon);

  while(!checkpid(daemon,&pid)){
    if(kill_daemon)
      unlink(daemon);
    else if(!writepid(daemon))
      exit(5);
    
    if(pid!=0){
      if(!kill(pid,SIGTERM)) sleep(3+(getpid()%7));
	 /* Allow a few seconds for cleaning up, then kill -9 it */
      kill(pid,SIGKILL);
      fprintf(fstdio[1],"loop1b\n");
    };
    if(kill_daemon) exit(0);
  };

  fprintf(fstdio[1],"%s\n","Old daemon killed");

}

