/*
 *		BCR Mail Handler, version 3.1
 *
 *	      Copyright (c) 1994 Bill C. Riemers
 *		  All Rights Reserved
 *
 *  This following is the standard GNU notice of copyright.  The only
 *  exception is I maintain I own this program and reserve all future
 *  rights.  (Meaning I might use a different copyright on future 
 *  releases, or violate my own copyright anyway I see fit.)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; version 2 of the License.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


char *hash(char *path,char *name);

char *parseaddress(char *line,char **newline);

char *strcasestr(char *haystack,char *needle);

int checkaccess(char *home,char *from,char *to,char *extra);

int checkforself(char *whoami,char *from,char *to);

int checkpid(char *daemon,int *pid);

int getfiletype(char *file,char *path,char *base,int *size,int *compress);

int casestep(char *ex,char *string);

int mailforward(char *mailbox,char *to,char *hostname,char *smtpservice);

int outgoing(char *queue);

#ifdef INCLUDED_READLINE
int parseheader(struct BFILE *input,char *from,char *reply,char *to,
  char **subject,int *hops);
#endif

#ifdef INCLUDED_READLINE
int readline(struct BFILE *input,int n);
#endif

int forward(char opt,char *mailbox,char *to,char *hostname,char *smtpservice);

int searchforuser(FILE *fd,char *from,char *extra);

int termforward(char *mailbox,char *forward);

int writepid(char *daemon);

long queuefiles(int nsubjects,char **subject,char *from,char *home,
  char *basepath,int max_size); 

void daemonkill(char *daemon,int kill_daemon);

void daemonloop(char option,char *daemon,char *queue,
  char *mailbox,char *command,char **arguments); 

void daemonputenv(char *queuedir,char *mailbox,char *queue,char *user,
  char *home); 

void daemonsignal(char *daemon);

void fstdioopen(void);

#ifdef INCLUDED_READLINE
void mailme(struct BFILE *input,char *user,char *home,long flags);
#endif

#ifdef IS_STDIO
void queueletter(FILE *fd,int binary,int compress,char *replyto,char *file,
  char *expression,char *subject,char last); 
#endif

void signaldaemon(char *home,char *daemon_name,long flags);

void forward_abort(void);

#ifdef IS_STDIO
void forward_quit(FILE *fdin);
#endif

void version(void);

