/* Apple II Simulator */
/* Slotbeschreibung fuer Languagecard */
/* Peter Koch, 7.1.93 */

extern int readinhibit;
extern int writeinhibit;
extern int slot;

/* Language Card Ram */
unsigned char lcramSLOT[0x4000];

/* Switches */
int readableSLOT,writableSLOT,secondSLOT,bank2SLOT;

int getC0SLOTX(adr)
int adr;
{
	switch (adr & 0x03)
	{
		case 0: /* C080 */
			secondSLOT=0;
			readableSLOT=1;
			writableSLOT=0;
			readinhibit=SLOT;
			writeinhibit= -1;
		break;

		case 1: /* C081 */
			readableSLOT=0;
			readinhibit= -1;
			if (secondSLOT)
			{
				writableSLOT=1;
				writeinhibit=SLOT;
			}
			secondSLOT=1;
		break;

		case 2: /* C082 */
			secondSLOT=0;
			readableSLOT=0;
			writableSLOT=0;
			readinhibit= -1;
			writeinhibit= -1;
		break;

		case 3: /* C083 */
			readableSLOT=1;
			readinhibit=SLOT;
			if (secondSLOT)
			{
				writableSLOT=1;
				writeinhibit=SLOT;
			}
			secondSLOT=1;
		break;
	}

	if (adr & 0x08)
		bank2SLOT=1;
	else
		bank2SLOT=0;
}

void putC0SLOTX(adr,value)
int adr;
int value;
{
	value=getC0SLOTX(adr);
}

int getCSLOTXX(adr)
int adr;
{
	/* Unused */
}

void putCSLOTXX(adr,value)
int adr;
int value;
{
	/* Unused */
}

int getSLOTC8XX(adr)
int adr;
{
	/* Unused */
}

void putSLOTC8XX(adr,value)
int adr;
int value;
{
	/* Unused */
}

int getSLOTinhibit(adr)
int adr;
{
	if (adr>=0xe000)
		return(lcramSLOT[adr-0xc000]);
	else
		if (bank2SLOT)
			return(lcramSLOT[adr-0xd000]);
		else
			return(lcramSLOT[adr-0xc000]);
}

void putSLOTinhibit(adr,value)
int adr;
int value;
{
	if (adr>=0xe000)
		lcramSLOT[adr-0xc000]=value;
	else
		if (bank2SLOT)
			lcramSLOT[adr-0xd000]=value;
		else
			lcramSLOT[adr-0xc000]=value;
}

void initslotSLOT()
{
	readableSLOT=0;
	writableSLOT=1;
	bank2SLOT=0;
	secondSLOT=0;

	writeinhibit=SLOT;
}
